Merge branch 'master' into staging

This commit is contained in:
Vladimír Čunát
2016-02-17 10:06:31 +01:00
456 changed files with 22536 additions and 2438 deletions

View File

@@ -102,6 +102,23 @@ hash_from_ref(){
git ls-remote origin | sed -n "\,\t$ref, { s,\(.*\)\t\(.*\),\1,; p; q}"
}
# Returns a name based on the url and reference
#
# This function needs to be in sync with nix's fetchgit implementation
# of urlToName() to re-use the same nix store paths.
url_to_name(){
local url=$1
local ref=$2
# basename removes the / and .git suffixes
local base=$(basename "$url" .git)
if [[ $ref =~ [a-z0-9]+ ]]; then
echo "$base-${ref:0:7}"
else
echo $base
fi
}
# Fetch everything and checkout the right sha1
checkout_hash(){
local hash="$1"
@@ -288,7 +305,7 @@ else
# If the hash was given, a file with that hash may already be in the
# store.
if test -n "$expHash"; then
finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" git-export)
finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" "$(url_to_name "$url" "$rev")")
if ! nix-store --check-validity "$finalPath" 2> /dev/null; then
finalPath=
fi
@@ -302,7 +319,7 @@ else
tmpPath="$(mktemp -d "${TMPDIR:-/tmp}/git-checkout-tmp-XXXXXXXX")"
trap "rm -rf \"$tmpPath\"" EXIT
tmpFile="$tmpPath/git-export"
tmpFile="$tmpPath/$(url_to_name "$url" "$rev")"
mkdir "$tmpFile"
# Perform the checkout.
@@ -313,7 +330,7 @@ else
if ! test -n "$QUIET"; then echo "hash is $hash" >&2; fi
# Add the downloaded file to the Nix store.
finalPath=$(nix-store --add-fixed --recursive "$hashType" $tmpFile)
finalPath=$(nix-store --add-fixed --recursive "$hashType" "$tmpFile")
if test -n "$expHash" -a "$expHash" != "$hash"; then
echo "hash mismatch for URL \`$url'"

View File

@@ -5,79 +5,79 @@ url=$1
rev=$2
expHash=$3
hashType=$NIX_HASH_ALGO
if test -z "$hashType"; then
hashType=sha256
fi
if test -z "$hashFormat"; then
hashFormat=--base32
hashType="${NIX_HASH_ALGO:-sha256}"
hashFormat=${hashFormat:-"--base32"}
rev="${rev:-tip}"
LOG() {
echo "$@" >&2
}
die() {
LOG "$@"
exit 1
}
if [[ -z "$url" || "$url" == "--help" ]]; then
die "Usage: nix-prefetch-hg URL [rev [EXPECTED-HASH]]"
fi
if test -z "$url"; then
echo "syntax: nix-prefetch-hg URL [rev [EXPECTED-HASH]]" >&2
exit 1
fi
if test "$fetchSubrepos" == 1; then
if [[ "${fetchSubrepos:-0}" == 1 ]]; then
subrepoClause=S
else
subrepoClause=
fi
test -n "$rev" || rev="tip"
# If the hash was given, a file with that hash may already be in the
# store.
if test -n "$expHash"; then
if [[ -n "$expHash" ]]; then
finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" hg-archive)
if ! nix-store --check-validity "$finalPath" 2> /dev/null; then
finalPath=
fi
hash=$expHash
hash="$expHash"
fi
# If we don't know the hash or a path with that hash doesn't exist,
# download the file and add it to the store.
if test -z "$finalPath"; then
if [[ -z "$finalPath" ]]; then
tmpPath="$(mktemp -d "${TMPDIR:-/tmp}/hg-checkout-tmp-XXXXXXXX")"
trap "rm -rf \"$tmpPath\"" EXIT
cleanup() { x=$?; rm -rf "$tmpPath"; exit $x; }; trap cleanup EXIT
tmpArchive="$tmpPath/hg-archive"
# Perform the checkout.
if [[ $url != /* ]]; then
tmpClone=$tmpPath/hg-clone
hg clone -q -y -U "$url" $tmpClone >&2
if [[ "$url" != /* ]]; then
tmpClone="$tmpPath/hg-clone"
hg clone -q -y -U "$url" "$tmpClone" >&2
else
tmpClone=$url
fi
hg archive -q$subrepoClause -y -r "$rev" --cwd $tmpClone $tmpArchive
rm -f $tmpArchive/.hg_archival.txt
hg archive -q$subrepoClause -y -r "$rev" --cwd "$tmpClone" "$tmpArchive"
rm -f "$tmpArchive/.hg_archival.txt"
echo "hg revision is $(cd $tmpClone; hg id -r "$rev" -i)"
LOG "hg revision is $(cd "$tmpClone"; hg id -r "$rev" -i)"
# Compute the hash.
hash=$(nix-hash --type $hashType $hashFormat $tmpArchive)
if ! test -n "$QUIET"; then echo "hash is $hash" >&2; fi
hash=$(nix-hash --type "$hashType" "$hashFormat" "$tmpArchive")
if [[ -z "$QUIET" ]]; then LOG "hash is $hash"; fi
# Add the downloaded file to the Nix store.
finalPath=$(nix-store --add-fixed --recursive "$hashType" $tmpArchive)
finalPath=$(nix-store --add-fixed --recursive "$hashType" "$tmpArchive")
if test -n "$expHash" -a "$expHash" != "$hash"; then
echo "hash mismatch for URL \`$url'"
exit 1
if [[ -n "$expHash" && "$expHash" != "$hash" ]]; then
die "ERROR: hash mismatch for URL \`$url'"
fi
fi
if ! test -n "$QUIET"; then echo "path is $finalPath" >&2; fi
if [[ -z "$QUIET" ]]; then LOG "path is $finalPath"; fi
echo $hash
echo "$hash"
if test -n "$PRINT_PATH"; then
echo $finalPath
if [[ -n "$PRINT_PATH" ]]; then
echo "$finalPath"
fi